AWSTemplateFormatVersion: "2010-09-09"

Description: ST-CC-VPN Layer
# Stack name - ST-CC-VPN
Parameters:
  AMIImage:
    Type: String
    # OpenVPN Access Server 2.1.4 BYOL
    Default: ami-e8d67288
  AdminUser:
    Type: String
    Default: vadmin
  AdminPassword:
    Type: String
    Default: Qazx123!#
  ServerName:
    Type: String
    Default: st-cc-vpn-1a
  ServerIpAddress:
    Type: String
    Default: 10.1.1.11

Resources:
  # 1 - Create EIP for ST-CC-VPN-1A
  STCCVPNEIP:
    Description: Create EIP for ST-CC-VPN-1
    Type: AWS::EC2::EIP
    Properties:
      Domain: !ImportValue STVPC

  InstanceProfile:
    Type: AWS::IAM::InstanceProfile
    Properties:
      Path: /
      Roles:
        - STServersRole

  # 1 - Create ST-CC-VPN-1A
  STCCVPN1a:
    DependsOn: STCCVPNEIP
    Type: AWS::EC2::Instance
    Properties:
      ImageId:
        Ref: AMIImage
      Tags:
        - Key: Name
          Value:
            Ref: ServerName
      InstanceType: t2.micro
      DisableApiTermination: False
      InstanceInitiatedShutdownBehavior: stop
      Monitoring: False
      KeyName: "ST-Sviridov-OR"
      IamInstanceProfile:
        Ref: InstanceProfile
      BlockDeviceMappings:
        - DeviceName: "/dev/sda1"
          Ebs:
            VolumeType: "standard"
            VolumeSize: "10"
      NetworkInterfaces:
        - AssociatePublicIpAddress: "true"
          DeviceIndex: "0"
          GroupSet:
            - !ImportValue STCCPublicSecGP
          PrivateIpAddress:
            Ref: ServerIpAddress
          SubnetId: !ImportValue STCCPublicSubnetA

  #Associate Elastic IP with ST-CC-VPN-1A instance
  STCCVPNEIPAssoc:
    DependsOn: STCCVPN1a
    Type: AWS::EC2::EIPAssociation
    Properties:
      InstanceId:
        Ref: STCCVPN1a
      AllocationId:
        Fn::GetAtt:
            - STCCVPNEIP
            - AllocationId

Outputs:
  STCCVPN1a:
    Value:
      Ref: STCCVPN1a
    Export:
      Name: STCCVPN1a
